package org.etsi.mts.ttcn.part9.xmldiff;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.Reader;

import org.junit.Before;
import org.junit.Test;

import static org.junit.Assert.*;

public class TestDiff3 {
	public static String FILE_base = "Pos_07060101_extending_simple_content_001.xml";
	public static String FILE_ttwb = "generated_ttwb.xml";
	public static String FILE_tc = "generated_tc.xml";
	
	private File root;
	private XmlDiff differ;
	private StringBuilder errors;
	private Reader actual;
	
	@Before
	public void setUp() throws IOException {
		root = new File("xml/003");
		differ = new XmlDiff(new File(root, FILE_base), null, null);
		errors = new StringBuilder();
	}
	
	@Test
	public void test_ttwb() throws IOException, XmlDiffError {
		actual = new FileReader(new File(root, FILE_ttwb));
		
		boolean v = differ.diff(actual, errors);
		assertEquals("", errors.toString());
		assertTrue(v);
	}
	
	@Test
	public void test_tc() throws IOException, XmlDiffError {
		actual = new FileReader(new File(root, FILE_tc));
		
		boolean v = differ.diff(actual, errors);
		
		assertFalse(v);
		assertTrue(errors.toString().contains("attribute"));
	}
}
